local HealthBarEmpty = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/HealthBarEmpty")
local HealthBarFull = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/HealthBarFull")
local ArmorBarEmpty = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/ArmorBarEmpty")
local ArmorBarFull = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/ArmorBarFull")
local AmmoBarEmpty = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/AmmoBarEmpty")
local AmmoBarFull = surface.GetTextureID("VGUI/CondemnedCriminalOriginsHud/AmmoBarFull")

CreateClientConVar("WHBHudEnabled",1,true,false)
CreateClientConVar("WHBHudHealthW",5,true,false)
CreateClientConVar("WHBHudHealthH",5,true,false)
CreateClientConVar("WHBHudArmorW",5,true,false)
CreateClientConVar("WHBHudArmorH",50,true,false)
CreateClientConVar("WHBHudAmmoW",5,true,false)
CreateClientConVar("WHBHudAmmoH",95,true,false)

MaxClip = {}

function HealthBar()
	if (GetConVarNumber("WHBHudEnabled")==1) then
		local You = LocalPlayer()
		local Weapon = You:GetActiveWeapon()
		
		if (Weapon=="Camera") then return end
		
		-- Where do we place the hud?
		local HealthBarLocationW = GetConVarNumber("WHBHudHealthW")
		local HealthBarLocationH = GetConVarNumber("WHBHudHealthH")
		local ArmorBarLocationW = GetConVarNumber("WHBHudArmorW")
		local ArmorBarLocationH = GetConVarNumber("WHBHudArmorH")
		local AmmoBarLocationW = GetConVarNumber("WHBHudAmmoW")
		local AmmoBarLocationH = GetConVarNumber("WHBHudAmmoH")
		
		-- Where does the bar on the hud start?
		local HealthBarPercentageStartW = HealthBarLocationW+3
		local HealthBarPercentageStartH = HealthBarLocationH+16
		local ArmorBarPercentageStartW = ArmorBarLocationW+3
		local ArmorBarPercentageStartH = ArmorBarLocationH+16
		local AmmoBarPercentageStartW = AmmoBarLocationW+3
		local AmmoBarPercentageStartH = AmmoBarLocationH+16
		
		-- Draw hud
		surface.SetDrawColor(255,255,255,255)
		
		-- Health
		surface.SetTexture(HealthBarEmpty)
		surface.DrawTexturedRect(HealthBarLocationW,HealthBarLocationH,256,128)
		
		if (!You.HealthOnBar) then
			You.HealthOnBar = 100 
		end
		if (You:Health() and You.HealthOnBar) then
			if (You.HealthOnBar > You:Health()) then
				You.HealthOnBar = You.HealthOnBar-RealFrameTime()*50
				if (You.HealthOnBar < You:Health()) then
					You.HealthOnBar = You:Health() 
				end
			elseif (You.HealthOnBar < You:Health()) then
				if (You.HealthOnBar > 100) then
					You.HealthOnBar = 100 end
				You.HealthOnBar = You.HealthOnBar+RealFrameTime()*50
				if (You.HealthOnBar > You:Health()) then
					You.HealthOnBar = You:Health()
				end
			end
		end
		
		surface.SetTexture(HealthBarFull)
		render.SetScissorRect(HealthBarPercentageStartW,HealthBarPercentageStartH,HealthBarPercentageStartW+math.Clamp(You.HealthOnBar/100*177,0,177),HealthBarPercentageStartH+22,true)
		surface.DrawTexturedRect(HealthBarLocationW,HealthBarLocationH,256,128)
		render.SetScissorRect(HealthBarPercentageStartW,HealthBarPercentageStartH,HealthBarPercentageStartW+math.Clamp(You.HealthOnBar/100*177,0,177),HealthBarPercentageStartH+22,false)
		
		if (You:Health()<=0) then
			draw.SimpleText("Dead","ScoreboardText",HealthBarPercentageStartW+5,HealthBarPercentageStartH+2,Color(255,255,0,255),0,0);
		else
			draw.SimpleText(You:Health().."%","ScoreboardText",HealthBarPercentageStartW+5,HealthBarPercentageStartH+2,Color(255,255,0,255),0,0);
		end
		
		-- Armor
		if (!You.ArmorOnBar) then
			You.ArmorOnBar = 0
		end
		if (You:Armor() and You.ArmorOnBar) then
			if (You.ArmorOnBar > You:Armor()) then
				You.ArmorOnBar = You.ArmorOnBar-RealFrameTime()*50
				if (You.ArmorOnBar < You:Armor()) then
					You.ArmorOnBar = You:Armor() 
				end
			elseif (You.ArmorOnBar < You:Armor()) then
				if (You.ArmorOnBar > 100) then
					You.ArmorOnBar = 100 end
				You.ArmorOnBar = You.ArmorOnBar+RealFrameTime()*50
				if (You.ArmorOnBar > You:Armor()) then
					You.ArmorOnBar = You:Armor()
				end
			end
		end
	
		if (You:Armor()>=1) then
			surface.SetTexture(ArmorBarEmpty)
			surface.DrawTexturedRect(ArmorBarLocationW,ArmorBarLocationH,256,128)
			
			surface.SetTexture(ArmorBarFull)
			render.SetScissorRect(ArmorBarPercentageStartW,ArmorBarPercentageStartH,ArmorBarPercentageStartW+math.Clamp(You.ArmorOnBar/100*177,0,177),ArmorBarPercentageStartH+22,true)
			surface.DrawTexturedRect(ArmorBarLocationW,ArmorBarLocationH,256,128)
			render.SetScissorRect(ArmorBarPercentageStartW,ArmorBarPercentageStartH,ArmorBarPercentageStartW+math.Clamp(You.ArmorOnBar/100*177,0,177),ArmorBarPercentageStartH+22,false)
			
			draw.SimpleText(You:Armor().."%","ScoreboardText",ArmorBarPercentageStartW+5,ArmorBarPercentageStartH+2,Color(0,180,180,255),0,0);
		end
		
		-- Ammo
		if (Weapon:IsValid()) then
			local Clip = Weapon:Clip1()
			local Spare = You:GetAmmoCount(Weapon:GetPrimaryAmmoType())
			local SecAmmo = You:GetAmmoCount(Weapon:GetSecondaryAmmoType())
			
			if (!MaxClip[Weapon]) then
				MaxClip[Weapon]=Clip
			elseif (Clip>MaxClip[Weapon]) then
				MaxClip[Weapon]=Clip
			end
			
			if (Clip>0 or Spare>0 or SecAmmo>0) then
				surface.SetTexture(AmmoBarEmpty)
				surface.DrawTexturedRect(AmmoBarLocationW,AmmoBarLocationH,256,128)
				
				surface.SetTexture(AmmoBarFull)
				render.SetScissorRect(AmmoBarPercentageStartW,AmmoBarPercentageStartH,AmmoBarPercentageStartW+math.Clamp(math.Round((177*Clip)/MaxClip[Weapon]),0,177),AmmoBarPercentageStartH+22,true)
				surface.DrawTexturedRect(AmmoBarLocationW,AmmoBarLocationH,256,128)
				render.SetScissorRect(AmmoBarPercentageStartW,AmmoBarPercentageStartH,AmmoBarPercentageStartW+math.Clamp(math.Round((177*Clip)/MaxClip[Weapon]),0,177),AmmoBarPercentageStartH+22,false)
				
				if (Clip>0 and  Spare>0 and SecAmmo>0) then
					draw.SimpleText(Clip.."/"..Spare.."    Sec: "..SecAmmo,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip>0 and Spare>0 and SecAmmo<=0) then
					draw.SimpleText(Clip.."/"..Spare,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip>0 and Spare<=0 and SecAmmo>0) then
					draw.SimpleText(Clip.."    Secondary: "..SecAmmo,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip>0 and Spare<=0 and SecAmmo<=0) then
					draw.SimpleText(Clip,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip<=0 and Spare>0 and SecAmmo>0) then
					draw.SimpleText(Spare.."    Sec: "..SecAmmo,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip<=0 and Spare>0 and SecAmmo<=0) then
					draw.SimpleText(Spare,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(0,0,0,255),0,0);
				elseif (Clip<=0 and Spare<=0 and SecAmmo>0) then
					draw.SimpleText("Secondary: "..SecAmmo,"ScoreboardText",AmmoBarPercentageStartW+5,AmmoBarPercentageStartH+2,Color(50,0,50,255),0,0);
				end
			end
		end
	end
end
hook.Add("HUDPaint","HealthBar",HealthBar)

function HideHUD(name)
	if(GetConVarNumber("WHBHudEnabled")==1) then
		for k, v in pairs{"CHudHealth", "CHudBattery", "CHudAmmo", "CHudSecondaryAmmo"} do
			if name == v then return false end
		end
	end
end
hook.Add("HUDShouldDraw","HideHUD",HideHUD)